VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Shell WinZip"
   ClientHeight    =   2355
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3900
   LinkTopic       =   "Form1"
   ScaleHeight     =   2355
   ScaleWidth      =   3900
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdViewUnzip 
      Caption         =   "View Unzipped Files"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   1680
      Visible         =   0   'False
      Width           =   3495
   End
   Begin VB.CommandButton cmdUnWinZip 
      Caption         =   "UnZip Project Files"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   1200
      Visible         =   0   'False
      Width           =   3495
   End
   Begin VB.CommandButton cmdViewWinZip 
      Caption         =   "View Zip File"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Visible         =   0   'False
      Width           =   3495
   End
   Begin VB.CommandButton cmdWinZip 
      Caption         =   "Zip Project Files"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   3495
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' From WinZip Help files:
' "filenames containing spaces must be
' enclosed in double quotes."

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Private m_AppPath As String
Private m_TempPath As String

' Remove the temp directory.
Private Sub Form_Unload(Cancel As Integer)
Dim next_file As String

    ' Remove the files in the directory.
    next_file = Dir(m_TempPath & "*.*", vbNormal)
    Do While next_file <> ""
        Kill m_TempPath & next_file
        next_file = Dir
    Loop

    ' Remove the directory.
    RmDir m_TempPath
End Sub
' Zip or unzip the files.
' The default location of the winzip32.exe is
' C:\Program Files\WinZip\. If your winzip32.exe
' is in another folder, change ZIP_EXE accordingly.
Sub WinZipSub(ByVal source As String, ByVal target As String, ByVal zip_it As Boolean)
Const ZIP_EXE As String = """C:\Program Files\WinZip\winzip32"""

    If zip_it = True Then
        ' Zip appending the source file to the target.
        Shell ZIP_EXE & " -a " & target & " " & source, vbHide
    Else
        ' Extract the target to the source directory.
        Shell ZIP_EXE & " -e " & target & " " & source, vbHide
    End If
End Sub

' Unzip the zip file.
Private Sub cmdUnWinZip_Click()
Dim target As String
Dim source As String

    ' Compose the source (destination directory)
    ' and target (Zip file) names.
    source = """" & m_TempPath & """"
    target = """" & m_AppPath & "temp\Project.zip" & """"

    ' Extract the files.
    WinZipSub source, target, False

    cmdViewUnzip.Visible = True
End Sub

' Open the temp directory to display its files.
Private Sub cmdViewUnzip_Click()
    ' Open the directory.
    ShellExecute 0, "Open", """" & m_TempPath & """", vbNullString, vbNullString, 1
End Sub

' Open the zip file.
Private Sub cmdViewWinZip_Click()
    ' Open the Zip file.
    ShellExecute 0, "Open", """" & m_AppPath & "temp\Project.zip" & """", vbNullString, vbNullString, 1
    cmdUnWinZip.Visible = True
End Sub

' Zip up the files in the current directory.
Private Sub cmdWinZip_Click()
Dim next_file As String
Dim target As String
Dim source As String

    ' Loop over all the files in the current directory.
    next_file = Dir(m_AppPath & "*.*", vbNormal)
    Do While next_file <> ""
        source = """" & m_AppPath & next_file & """"
        target = """" & m_AppPath & "temp\Project.zip" & """"

        ' Add this file to Project.zip
        WinZipSub source, target, True
        next_file = Dir
    Loop

    cmdViewWinZip.Visible = True
End Sub
' Create the temp directory.
Private Sub Form_Load()
    ' Get the application and temp directories.
    m_AppPath = App.Path
    If Right$(m_AppPath, 1) <> "\" Then m_AppPath = m_AppPath & "\"
    m_TempPath = m_AppPath & "temp\"

    ' Make the temp directory if it doesn't exist.
    If Dir(m_TempPath, vbDirectory) = "" _
        Then MkDir m_TempPath
End Sub


